﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CPlugIn
{
    public interface IStoryEditorPlugin
    {
        /// <summary>
        /// 初期化
        /// </summary>
        /// <returns></returns>
        bool init(string strDllFileName);
        /// <summary>
        /// バージョン情報プロパティ
        /// </summary>
        string Version { get; }
        /// <summary>
        /// コピーライト
        /// </summary>
        string Copyright { get; }
        /// <summary>
        /// ノードを選択された時に、実行される
        /// </summary>
        bool isNodeOpen { get; }
        /// <summary>
        /// 表示用メニュー
        /// </summary>
        /// <returns></returns>
        ToolStripMenuItem menu(string strDllFileName);
        /// <summary>
        /// 
        /// </summary>
        /// <param name="mPluginData"></param>
        /// <returns></returns>
        CStoryEditorPlugin run(CStoryEditorPlugin mPluginData);
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        DialogResult config(string strDllFileName);
        /// <summary>
        /// 設定項目がある場合に、True
        /// </summary>
        bool isConfig { get; }
        /// <summary>
        /// 設定用のメニューの項目
        /// </summary>
        /// <param name="strDllFileName"></param>
        /// <returns></returns>
        ToolStripMenuItem configMenu(string strDllFileName);
    }

    public class CStoryEditorPlugin
    {
        public bool bMenu { get; set; }
        public string strDllFileName { get; set; }
        //
        public string strXmlFileName { get; set; }
        //
        public string strNodeTypeName { get; set; }
        public int strNodeTypeNumber { get; set; }
        public string strNodeTitle { get; set; }
        public string strNodeFileName { get; set; }
        //
        public string[] allFileList { get; set; }
        //
        public DialogResult result { get; set; }
    }
}
