﻿using CPlugIn;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CToDo
{
    public class CToDo : IStoryEditorPlugin
    {
        public string Copyright
        {
            get
            {
                return "2018 北きつね";
            }
        }

        public bool isConfig
        {
            get
            {
                return true;
            }
        }

        public string Version
        {
            get
            {
                return "1.0.0.1";
            }
        }

        public bool isNodeOpen
        {
            get
            {
                return false;
            }
        }

        public bool init(string strDllFileName)
        {
            return true; ;
        }

        public DialogResult config(string strDllFileName)
        {
            frmConfig mApp = new frmConfig();
            return mApp.ShowDialog();
        }

        private ToolStripMenuItem getMenu(string menuText, string menuTool, string strDllFile, string strImageFile)
        {
            ToolStripMenuItem item = new ToolStripMenuItem();
            item.Text = menuText;
            item.ToolTipText = menuTool;
            Image img = getIcon(strDllFile, strImageFile);
            if (img != null)
            {
                item.Image = getIcon(strDllFile, strImageFile);
            }
            item.Tag = strDllFile;
            //
            return item;
        }
        private Image getIcon(string strDllFile, string strImageFile)
        {
            Image img = null;
            string myIconFile = System.IO.Path.GetDirectoryName(strDllFile) + @"\" + strImageFile;
            if (System.IO.File.Exists(myIconFile))
            {
                img = Bitmap.FromFile(myIconFile);
            }
            //
            return img;
        }

        public ToolStripMenuItem menu(string strDllFileName)
        {
            return getMenu("ToDo", "ToDo", strDllFileName, "ToDo.png");
        }
        public ToolStripMenuItem configMenu(string strDllFileName)
        {
            return getMenu("ToDo 設定", "ToDo 設定", strDllFileName, "ToDo.png");
        }

        public CStoryEditorPlugin run(CStoryEditorPlugin mPluginData)
        {
            CStoryEditorPlugin retData = mPluginData;
            frmMain mApp = new frmMain();
            mApp.strXmlFileName = mPluginData.strXmlFileName;
            mApp.strNodeFileName = mPluginData.strNodeFileName;
            //
            retData.result = mApp.ShowDialog();
            return retData;
        }
    }
}
